const std = @import("std");
const builtin = @import("builtin");

const craftflut = @import("craftflut");

pub const std_options: std.Options = .{
    .log_level = if (builtin.mode == .Debug) .debug else .info,
};

pub fn main() !void {
    var gpa = std.heap.GeneralPurposeAllocator(.{
        .thread_safe = true,
    }){};
    defer _ = gpa.deinit();
    const allocator = gpa.allocator();

    {
        const config = craftflut.Config{
            .web_port = 3000,
            .web_threads = 16,
        };
        try craftflut.start(allocator, &config);
    }
}
