const std = @import("std");

const msg_queue = @import("msg_queue/root.zig");
const dispatchers = @import("dispatchers/root.zig");
const web = @import("web/root.zig");

pub const Config = struct {
    web_port: u16,
    web_threads: i16,
};

fn receiver(queue: *msg_queue.MsgQueueUnmanaged(msg_queue.messages.BlockUpdate)) void {
    while (true) {
        const packet = queue.dequeue();
        std.log.info("packet: {}", .{packet});
    }
}

pub fn start(allocator: std.mem.Allocator, config: *const Config) !void {
    // var update_queue = UpdateQueue.init();
    const capacity: usize = 1024;
    var queue = try msg_queue.MsgQueueManaged(msg_queue.messages.BlockUpdate).init(allocator, capacity);
    defer queue.deinit();

    _ = try std.Thread.spawn(.{}, receiver, .{queue.unmanaged()});

    try web.start(allocator, config.web_threads, config.web_port, queue.unmanaged());
}
